/////////////////////////////////////////////////////////////////////////////////

// Original obtained from GlsSandbox.com
// Adapted, trivialy, for VGHD by TheEmu.

uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

// The originals of these shaders did not take gl_FragCoord.w  into
// account so the iStripper scale attribute would  have  no  effect
// when used ina scene node that used one of them. I have therefore
// performed a global replace to substitute scaled_gl_FragCoord for
// gl_FragCoord and declare it here. TheEmu 2016/12/15

#define scaled_gl_FragCoord vec4(gl_FragCoord.xyz*gl_FragCoord.w,1.0)

// Use defines here rather than edit the body of the code.

#define time u_Elapsed
#define resolution u_WindowSize
#define mouse vec2(0.0,0.0)
#define surfacePosition vec2(2.0*scaled_gl_FragCoord.xy/resolution-1.0)

/////////////////////////////////////////////////////////////////////////////////

#ifdef GL_ES
precision mediump float;
#endif

// Rotating and Zooming Infinite Orgies at the same time!

// Rotating Orgy NOW

// "Fractal Orgy" by Pablo Romn Andrioli (Kali)

// some naughy boi coded this.....

#define VOYEUR_MODE

// uniform float time;
// uniform vec2 resolution;
// uniform vec2 mouse;

float orgy(vec2 p) {
	float pl=0., expsmo=0.;
	float t=sin(time*20.);
	float a=-.35+t*.02;
	p*=mat2(cos(a),sin(a),-sin(a),cos(a));
	p=p*.07+vec2(.728,-.565)+t*.017+vec2(0.,t*.014);
	for (int i=0; i<13; i++) {
		p.x=abs(p.x);
		p=p*2.+vec2(-2.,.85)-t*.04;
		p/=min(dot(p,p),1.06);  
		float l=length(p*p);
		expsmo+=exp(-1.2/abs(l-pl));
		pl=l;
	}
	return expsmo;
}


void main( void )
{
	vec2 uv = scaled_gl_FragCoord.xy/resolution.xy - .5;
	uv.x*=resolution.x/resolution.y;
	uv = mod((uv) * (4.0 + 2.0*sin(time)) + vec2(sin(time), sin(time*1.5)), 1.0) - 0.5;
  	
	float newX = uv.x * sin(time) + uv.y * cos(time);
	float newY = uv.x * cos(time) - uv.y * sin(time);
	uv = vec2(newX, newY);
	vec2 p=uv; p.x*=1.2; p*=1.1;
	p.y+=.2; p.x += .1;
	float o=clamp(orgy(p)*.07,.13,1.); o=pow(o,1.8);
	vec3 col=vec3(o*.8,o*o*.87,o*o*o*.9);
	float hole=(length(uv+vec2(.09,0.05))-.45);
	#ifdef VOYEUR_MODE 
		col*=pow(abs(1.-max(0.,hole)),80.);
	#endif
	gl_FragColor = vec4(col*2.1+.1, 1.0 );
   gl_FragColor *= gl_Color; // TheEmu 2016/12/15
}
